#include "LCD.h"
#include "font.h"
#include "delay.h"
#include "spi.h"
/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_DATA8(u8 dat)
{
	P_LCD_CS = 0;
	LCD_SendByte(dat);
	P_LCD_CS = 1;
}

/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_DATA16(u16 dat)
{
	P_LCD_CS = 0;
	LCD_SendByte((u8)(dat>>8));
	LCD_SendByte((u8)dat);
	P_LCD_CS = 1;
}

/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_REG(u8 dat)
{
	P_LCD_DC = 0;//д
	P_LCD_CS = 0;
	LCD_SendByte(dat);
	P_LCD_CS = 1;
	P_LCD_DC = 1;//д
}

/******************************************************************************
      ˵ˢĻ
      ݣ
      ֵ  
******************************************************************************/
void Reset()
{
    P_LCD_RST=0;
    delay_ms(100);
    P_LCD_RST=1;
    delay_ms(100);
}

void lcd_init()
{	
	SPI_Config(2, 2);
	Reset();//Reset before LCD Init.
	LCD_WR_REG(0x11);//Sleep exit
	delay_ms(120);
	LCD_WR_REG(0x21);//Display Inversion On
	LCD_WR_REG(0x21);

	LCD_WR_REG(0xB1); // Frame Rate Control (In normal mode/ Full colors).ȫģʽ֡ƵFrame rate=fosc/((RTNA x 2 + 40) x (LINE + FPA + BPA +2)) 
	LCD_WR_DATA8(0x05);//RTNA
	LCD_WR_DATA8(0x3A);//FPA
	LCD_WR_DATA8(0x3A);//BPA

	LCD_WR_REG(0xB2);// Frame Rate Control (In Idle mode/ 8-colors)ÿģʽ֡Ƶ
	LCD_WR_DATA8(0x05);
	LCD_WR_DATA8(0x3A);
	LCD_WR_DATA8(0x3A);

	LCD_WR_REG(0xB3);//Frame Rate Control (In Partial mode/ full colors)òģʽ/ȫɫ֡Ƶ
	/*dot inversion mode*/
	LCD_WR_DATA8(0x05);
	LCD_WR_DATA8(0x3A);
	LCD_WR_DATA8(0x3A);
	/*column inversion mode*/
	LCD_WR_DATA8(0x05);
	LCD_WR_DATA8(0x3A);
	LCD_WR_DATA8(0x3A);

	LCD_WR_REG(0xB4);//Display Inversion Controlʾתģʽ
	LCD_WR_DATA8(0x03);
	
	/***************
	AVDD 001
	VRHP4 00010
	MODE 00
	VRHN5 00
	****************/
	LCD_WR_REG(0xC0);//Power Control 1
	LCD_WR_DATA8(0x62);
	LCD_WR_DATA8(0x02);
	LCD_WR_DATA8(0x04);

	LCD_WR_REG(0xC1);//Power Control 2
	LCD_WR_DATA8(0xC0);

	LCD_WR_REG(0xC2);//Power Control 3 (in Normal mode/ Full colors)
	LCD_WR_DATA8(0x0D);
	LCD_WR_DATA8(0x00);

	LCD_WR_REG(0xC3);// Power Control 4 (in Idle mode/ 8-colors)
	LCD_WR_DATA8(0x8D);
	LCD_WR_DATA8(0x6A);

	LCD_WR_REG(0xC4);//Power Control 5 (in Partial mode/ full-colors)
	LCD_WR_DATA8(0x8D);
	LCD_WR_DATA8(0xEE);

	LCD_WR_REG(0xC5);//VCOM Control 1
	LCD_WR_DATA8(0x0E);

	LCD_WR_REG(0xE0);//Gamma (+polarity) Correction Characteristics Setting
	LCD_WR_DATA8(0x10);
	LCD_WR_DATA8(0x0E);
	LCD_WR_DATA8(0x02);
	LCD_WR_DATA8(0x03);
	LCD_WR_DATA8(0x0E);
	LCD_WR_DATA8(0x07);
	LCD_WR_DATA8(0x02);
	LCD_WR_DATA8(0x07);
	LCD_WR_DATA8(0x0A);
	LCD_WR_DATA8(0x12);
	LCD_WR_DATA8(0x27);
	LCD_WR_DATA8(0x37);
	LCD_WR_DATA8(0x00);
	LCD_WR_DATA8(0x0D);
	LCD_WR_DATA8(0x0E);
	LCD_WR_DATA8(0x10);

	LCD_WR_REG(0xE1);//Gamma -polarity Correction Characteristics Setting
	LCD_WR_DATA8(0x10);
	LCD_WR_DATA8(0x0E);
	LCD_WR_DATA8(0x03);
	LCD_WR_DATA8(0x03);
	LCD_WR_DATA8(0x0F);
	LCD_WR_DATA8(0x06);
	LCD_WR_DATA8(0x02);
	LCD_WR_DATA8(0x08);
	LCD_WR_DATA8(0x0A);
	LCD_WR_DATA8(0x13);
	LCD_WR_DATA8(0x26);
	LCD_WR_DATA8(0x36);
	LCD_WR_DATA8(0x00);
	LCD_WR_DATA8(0x0D);
	LCD_WR_DATA8(0x0E);
	LCD_WR_DATA8(0x10);

	LCD_WR_REG(0x3A);// Interface Pixel Format
	LCD_WR_DATA8(0x05);

	LCD_WR_REG(0x36);//Memory Data Access Control
	LCD_WR_DATA8(0xC8);

	LCD_WR_REG(0x29);//Display On

}

/*************************************************
LCD_Set_Region
ܣlcdʾڴдԶ
ڲxyյ
ֵ
*************************************************/
void Lcd_SetRegion(unsigned int x_start, unsigned int y_start, unsigned int x_end, unsigned int y_end)
{
    // еַΧX᷽
    LCD_WR_REG(0x2a); // ѡеַüĴӦֲе2AHַ
    LCD_WR_DATA8(0x00); // еַʼֵĸ8λΪ0
    LCD_WR_DATA8(x_start + 0x18); // еַʼֵĵ8λ0x18ΪоƬڲƫƻַӳ0x18
    LCD_WR_DATA8(0x00); // еֵַĸ8λΪ0
    LCD_WR_DATA8(x_end + 0x18); // еֵַĵ8λͬ0x18    + 

    // еַΧY᷽
    LCD_WR_REG(0x2b); // ѡеַüĴ
    LCD_WR_DATA8(0x00); // еַʼֵĸ8λΪ0
    LCD_WR_DATA8(y_start); // еַʼֵĵ8λ
    LCD_WR_DATA8(0x00); // еֵַĸ8λΪ0
    LCD_WR_DATA8(y_end); // еֵַĵ8λ
    LCD_WR_DATA8(0x2c); // ʾд
}

/*Ļϻһص*/
void PutPixel(uint x_start,uint y_start,uint color)
{
	Lcd_SetRegion(x_start,y_start,x_start+1,y_start+1);
	LCD_WR_DATA16(color);
}

/*Ļʾһɫ*/
void dsp_single_colour(int color)
{
 	uchar i,j;
	Lcd_SetRegion(0,0,80-1,160-1);
 	for (i=0;i<160;i++)
    	for (j=0;j<80;j++)
        	LCD_WR_DATA16(color);
}

//ôڷֿݣGui_DrawFont_GBK16
void Fast_DrawFont_GBK16(uint x, uint y, uint fc, uint bc, uchar *s)
{
    // ֲijѭkֿ
    unsigned char i, j;
    unsigned short k;
    // HZnumڼֿкֵ
    uint HZnum;
    // ֿкֵ
    HZnum = sizeof(hz16) / sizeof(typFNT_GBK16);
    // ѭֱַ
    while (*s){
        // ַASCIIڵ128ΪǺ֣GBK룩
        if ((*s) >= 128){
            // ֿ
            for (k = 0; k < HZnum; k++){
                // ֿƥĺ
                if ((hz16[k].Index[0] == *(s)) && (hz16[k].Index[1] == *(s + 1))){
                    // ʾΪ16x16أӦһֵĴС
                    Lcd_SetRegion(x, y, x + 16 - 1, y + 16 - 1);
                    // ѭƺֵÿһλ
                    for (i = 0; i < 16 * 2; i++){
                        for (j = 0; j < 8; j++){
                            // ֿжӦλΪ1ǰɫfc
                            if (hz16[k].Msk[i] & (0x80 >> j))
                                LCD_WR_DATA16(fc);
                            // ǰɫͱɫͬƱɫbc
                            else{
                                if (fc!= bc)
                                    LCD_WR_DATA16(bc);
                            }
                        }
                    }
                }
            }
            // ָƶһ֣GBKռ2ֽڣ
            s += 2;
            // Xƶ16أ׼һ
            x += 16;
        }
        // Ǻ֣ASCIIС128ָƶ1ֽ
        else
            s += 1;
    }
}
//˷溺ֽ
void Gui_DrawFont_GBK16(uint x, uint y, uint fc, uint bc, uchar *s)
{
    // ֲijѭkֿ⣬x0ڱʼX
    unsigned char i, j;
    unsigned short k, x0;
    x0 = x;
    // ѭֱַ
    while (*s){
        // ַASCIIڵ128ΪǺ֣GBK룩
        if ((*s) >= 128){
            // ֿ
            for (k = 0; k < hz16_num; k++){
                // ֿƥĺ
                if ((hz16[k].Index[0] == *(s)) && (hz16[k].Index[1] == *(s + 1))){
                    // ѭƺֵÿһλ
                    for (i = 0; i < 16; i++){
                        for (j = 0; j < 8; j++){
                            // ֿжӦλΪ1ǰɫfc
                            if (hz16[k].Msk[i * 2] & (0x80 >> j))
                                PutPixel(x + j, y + i, fc);
                            // ǰɫͱɫͬƱɫbc
                            else{
                                if (fc!= bc)
                                    PutPixel(x + j, y + i, bc);
                            }
                        }
                        for (j = 0; j < 8; j++){
                            // ֿжӦλΪ1ǰɫfc
                            if (hz16[k].Msk[i * 2 + 1] & (0x80 >> j))
                                PutPixel(x + j + 8, y + i, fc);
                            // ǰɫͱɫͬƱɫbc
                            else{
                                if (fc!= bc)
                                    PutPixel(x + j + 8, y + i, bc);
                            }
                        }
                    }
                }
            }
            // ָƶһ֣GBKռ2ֽڣ
            s += 2;
            // Xƶ16أ׼һ
            x += 16;
        }
        // Ǻ֣ASCIIС128ָƶ1ֽ
        else
            s += 1;
    }
}

void Font_Test(void)
{//ʾԽݳӻӭΪרҵע
	dsp_single_colour(WHITE);
	Fast_DrawFont_GBK16(8,10,BLUE,YELLOW,	"Ĳ");
	Fast_DrawFont_GBK16(0,30,RED,WHITE,	"ݳ");
	Fast_DrawFont_GBK16(16,50,BLUE,WHITE,	"ӭ");
	Fast_DrawFont_GBK16(8,70,WHITE,BLUE, 	"Ϊרע");
	Fast_DrawFont_GBK16(8,90,WHITE,BLUE,	"רҵ");

	delay_ms(180);//1800
}

void Gif(void)
{
	dsp_single_colour(WHITE);
}