#include "spi.h"


//========================================================================
// : void  SPI_Config(u8 SPI_io, u8 SPI_speed)
// : SPIʼ
// : io: лIO,            SS  MOSI MISO SCLK
//                       0: л P1.4 P1.5 P1.6 P1.7
//                       1: л P2.4 P2.5 P2.6 P2.7
//                       2: л P4.0 P4.1 P4.2 P4.3
//                       3: л P3.5 P3.4 P3.3 P3.2
//       SPI_speed: SPIٶ, 0: fosc/4,  1: fosc/8,  2: fosc/16,  3: fosc/2
// : none.
// 汾: VER1.0
// : 2024-8-13
// ע:
//========================================================================
void SPI_Config(u8 SPI_io, u8 SPI_speed)
{
	SPI_io &= 3;

	SPCTL = SPI_speed & 3;	//SPI ٶ, ִָ, ˳Bit7~Bit20
	SSIG = 1;				//1: SSţMSTRλǴӻ		0: SSھǴӻ
	SPEN = 1;				//1: SPI								0ֹSPISPIܽžΪͨIO
	DORD = 0;				//1LSBȷ								0MSBȷ
	MSTR = 1;				//1Ϊ								0Ϊӻ
	CPOL = 1;				//1: ʱSCLKΪߵƽ					0ʱSCLKΪ͵ƽ
	CPHA = 1;				//1: SCLKǰ,ز.			0: SCLKǰز,.
//	SPR1 = 0;				//SPR1,SPR0   00: fosc/4,     01: fosc/8
//	SPR0 = 0;				//            10: fosc/16,    11: fosc/2
	P_SW1 = (P_SW1 & ~0x0c) | ((SPI_io<<2) & 0x0c);		//лIO

	HSCLKDIV   = 1;			//HSCLKDIVʱӷƵ
	SPI_CLKDIV = 1;			//SPI_CLKDIVʱӷƵ
	SPSTAT = 0x80 + 0x40;	//0 SPIFWCOL־

	if(SPI_io == 0)
	{
		P1n_standard(0xf0);			//л P1.4(SS) P1.5(MOSI) P1.6(MISO) P1.7(SCLK), Ϊ׼˫
		PullUpEnable(P1PU, 0xf0);	//    ˿ڲ   PxPU, ҪõĶ˿ڶӦλΪ1
		P1n_push_pull(Pin7+Pin5);	//MOSI SCLKΪ
		SlewRateHigh(P1SR, Pin7+Pin5);	//MOSI SCLK˿Ϊģʽ   PxSR, ҪõĶ˿ڶӦλΪ1.    ģʽ3.3VʱٶȿԵ13.5MHz(27MHzƵSPIٶ2Ƶ)
	}
	else if(SPI_io == 1)
	{
		P2n_standard(0xf0);			//лP2.4(SS) P2.5(MOSI) P2.6(MISO) P2.7(SCLK), Ϊ׼˫
		PullUpEnable(P2PU, 0xf0);	//    ˿ڲ   PxPU, ҪõĶ˿ڶӦλΪ1
		P2n_push_pull(Pin7+Pin5);	//MOSI SCLKΪ
		SlewRateHigh(P2SR, Pin7+Pin5);	//MOSI SCLK˿Ϊģʽ   PxSR, ҪõĶ˿ڶӦλΪ1.    ģʽ3.3VʱٶȿԵ13.5MHz(27MHzƵSPIٶ2Ƶ)
	}
	else if(SPI_io == 2)
	{
		P4n_standard(0x0f);			//лP4.0(SS) P4.1(MOSI) P4.2(MISO) P4.3(SCLK), Ϊ׼˫
		PullUpEnable(P4PU, 0x0f);	//    ˿ڲ   PxPU, ҪõĶ˿ڶӦλΪ1
		P4n_push_pull(Pin3+Pin1);	//MOSI SCLKΪ
		SlewRateHigh(P4SR, Pin3+Pin1);	//MOSI SCLK˿Ϊģʽ   PxSR, ҪõĶ˿ڶӦλΪ1.    ģʽ3.3VʱٶȿԵ13.5MHz(27MHzƵSPIٶ2Ƶ)
	}
	else if(SPI_io == 3)
	{
		P3n_standard(0x3C);		//лP3.5(SS) P3.4(MOSI) P3.3(MISO) P3.2(SCLK), Ϊ׼˫
		PullUpEnable(P3PU, 0x3c);	//    ˿ڲ   PxPU, ҪõĶ˿ڶӦλΪ1
		P3n_push_pull(Pin4+Pin2);	//MOSI SCLKΪ
		SlewRateHigh(P3SR, Pin4+Pin2);	//MOSI SCLK˿Ϊģʽ   PxSR, ҪõĶ˿ڶӦλΪ1.    ģʽ3.3VʱٶȿԵ13.5MHz(27MHzƵSPIٶ2Ƶ)
	}
	

}


//========================================================================
// : дSPIһֽں
// : .
// : 
//========================================================================

void	LCD_SendByte(u8 dat)
{
	SPDAT = dat;	//һֽ
	while(SPIF == 0)	;			//ȴ
	SPSTAT = 0x80 + 0x40;			//0 SPIFWCOL־
}
